org.apache.sysds.runtime.compress.utils

## Class ABitmap

- java.lang.Object
- - org.apache.sysds.runtime.compress.utils.ABitmap

Direct Known Subclasses:
  Bitmap, BitmapLossy, MultiColBitmap

    public abstract class ABitmap
    extends Object

### Nested Class Summary

Nested Classes
`static class` `ABitmap.BitmapType`

### Constructor Summary

Constructors
Constructor and Description
`ABitmap(int numCols, IntArrayList[] offsetsLists, int rows)`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`boolean` `containsZero()`
`int` `getNumColumns()`
`abstract int` `getNumNonZerosInOffset(int idx)`
`long` `getNumOffsets()`
`int` `getNumOffsets(int ix)` Get the number of offsets for a specific unique offset.
`int` `getNumRows()`
`abstract int` `getNumValues()` Obtain number of distinct value groups in the column.
`IntArrayList[]` `getOffsetList()`
`IntArrayList` `getOffsetsList(int idx)`
`abstract ABitmap.BitmapType` `getType()`
`int` `getZeroCounts()`
`boolean` `isEmpty()`
`abstract boolean` `lossy()`
`abstract void` `sortValuesByFrequency()`
`String` `toString()`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### ABitmap

    public ABitmap(int numCols,
                   IntArrayList[] offsetsLists,
                   int rows)

### Method Detail

#### getNumColumns

    public int getNumColumns()

#### getNumRows

    public int getNumRows()

#### isEmpty

    public boolean isEmpty()

#### lossy

    public abstract boolean lossy()

#### getNumValues

    public abstract int getNumValues()

Obtain number of distinct value groups in the column. this number is also the number of bitmaps, since there is one bitmap per value

Returns:
  number of distinct value groups in the column;

#### getOffsetList

    public IntArrayList[] getOffsetList()

#### getOffsetsList

    public IntArrayList getOffsetsList(int idx)

#### getNumOffsets

    public long getNumOffsets()

#### getNumOffsets

    public int getNumOffsets(int ix)

Get the number of offsets for a specific unique offset.

Parameters:
  `ix` - The offset index.
Returns:
  The number of offsets for this unique value.

#### sortValuesByFrequency

    public abstract void sortValuesByFrequency()

#### containsZero

    public boolean containsZero()

#### getZeroCounts

    public int getZeroCounts()

#### getNumNonZerosInOffset

    public abstract int getNumNonZerosInOffset(int idx)

#### getType

    public abstract ABitmap.BitmapType getType()

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`